diff --git a/dlls/quartz/filtergraph.c b/dlls/quartz/filtergraph.c
index a99fdc80b..5f1b80d12 100644
--- a/dlls/quartz/filtergraph.c
+++ b/dlls/quartz/filtergraph.c
@@ -61,6 +61,7 @@ struct filter
     struct list entry;
     IBaseFilter *filter;
     IMediaSeeking *seeking;
+    IMediaPosition *position;
     WCHAR *name;
     BOOL sorting;
 };
@@ -98,7 +99,7 @@ struct filter_graph
     struct list filters;
     unsigned int name_index;
 
-    FILTER_STATE state;
+    OAFilterState state;
     TP_WORK *async_run_work;
 
     IReferenceClock *refClock;
@@ -181,7 +182,7 @@ static ULONG WINAPI EnumFilters_AddRef(IEnumFilters *iface)
     struct enum_filters *enum_filters = impl_from_IEnumFilters(iface);
     ULONG ref = InterlockedIncrement(&enum_filters->ref);
 
-    TRACE("%p increasing refcount to %lu.\n", enum_filters, ref);
+    TRACE("%p increasing refcount to %u.\n", enum_filters, ref);
 
     return ref;
 }
@@ -191,7 +192,7 @@ static ULONG WINAPI EnumFilters_Release(IEnumFilters *iface)
     struct enum_filters *enum_filters = impl_from_IEnumFilters(iface);
     ULONG ref = InterlockedDecrement(&enum_filters->ref);
 
-    TRACE("%p decreasing refcount to %lu.\n", enum_filters, ref);
+    TRACE("%p decreasing refcount to %u.\n", enum_filters, ref);
 
     if (!ref)
     {
@@ -208,7 +209,7 @@ static HRESULT WINAPI EnumFilters_Next(IEnumFilters *iface, ULONG count,
     struct enum_filters *enum_filters = impl_from_IEnumFilters(iface);
     unsigned int i = 0;
 
-    TRACE("enum_filters %p, count %lu, filters %p, fetched %p.\n",
+    TRACE("enum_filters %p, count %u, filters %p, fetched %p.\n",
             enum_filters, count, filters, fetched);
 
     if (enum_filters->version != enum_filters->graph->version)
@@ -238,7 +239,7 @@ static HRESULT WINAPI EnumFilters_Skip(IEnumFilters *iface, ULONG count)
 {
     struct enum_filters *enum_filters = impl_from_IEnumFilters(iface);
 
-    TRACE("enum_filters %p, count %lu.\n", enum_filters, count);
+    TRACE("enum_filters %p, count %u.\n", enum_filters, count);
 
     if (enum_filters->version != enum_filters->graph->version)
         return VFW_E_ENUM_OUT_OF_SYNC;
@@ -418,24 +419,23 @@ static HRESULT WINAPI FilterGraphInner_QueryInterface(IUnknown *iface, REFIID ri
 
 static ULONG WINAPI FilterGraphInner_AddRef(IUnknown *iface)
 {
-    struct filter_graph *graph = impl_from_IUnknown(iface);
-    ULONG refcount = InterlockedIncrement(&graph->ref);
+    struct filter_graph *This = impl_from_IUnknown(iface);
+    ULONG ref = InterlockedIncrement(&This->ref);
 
-    TRACE("%p increasing refcount to %lu.\n", graph, refcount);
+    TRACE("(%p)->(): new ref = %d\n", This, ref);
 
-    return refcount;
+    return ref;
 }
 
 static ULONG WINAPI FilterGraphInner_Release(IUnknown *iface)
 {
     struct filter_graph *This = impl_from_IUnknown(iface);
-    ULONG refcount = InterlockedDecrement(&This->ref);
+    ULONG ref = InterlockedDecrement(&This->ref);
     struct list *cursor;
 
-    TRACE("%p decreasing refcount to %lu.\n", This, refcount);
+    TRACE("(%p)->(): new ref = %d\n", This, ref);
 
-    if (!refcount)
-    {
+    if (ref == 0) {
         int i;
 
         This->ref = 1; /* guard against reentrancy (aggregation). */
@@ -477,7 +477,7 @@ static ULONG WINAPI FilterGraphInner_Release(IUnknown *iface)
 	DeleteCriticalSection(&This->cs);
         free(This);
     }
-    return refcount;
+    return ref;
 }
 
 static struct filter_graph *impl_from_IFilterGraph2(IFilterGraph2 *iface)
@@ -507,6 +507,13 @@ static IBaseFilter *find_filter_by_name(struct filter_graph *graph, const WCHAR
 {
     struct filter *filter;
 
+    /* King of Fighters XIII requests the WMV decoder filter by name to
+     * connect it to a Sample Grabber filter, return our custom decoder
+     * filter instance instead.
+     */
+    if (!wcscmp(name, L"WMVideo Decoder DMO"))
+        name = L"GStreamer splitter filter";
+
     LIST_FOR_EACH_ENTRY(filter, &graph->filters, struct filter, entry)
     {
         if (!wcscmp(filter->name, name))
@@ -542,6 +549,7 @@ static BOOL has_output_pins(IBaseFilter *filter)
 
 static void update_seeking(struct filter *filter)
 {
+    IMediaPosition *position;
     IMediaSeeking *seeking;
 
     if (!filter->seeking)
@@ -560,11 +568,19 @@ static void update_seeking(struct filter *filter)
                 IMediaSeeking_Release(seeking);
         }
     }
+
+    if (!filter->position)
+    {
+        /* Tokyo Xanadu eX+, same as above, same developer, destroys its filter when
+         * its IMediaPosition interface is released, so cache the interface instead
+         * of querying for it every time. */
+        if (SUCCEEDED(IBaseFilter_QueryInterface(filter->filter, &IID_IMediaPosition, (void **)&position)))
+            filter->position = position;
+    }
 }
 
 static BOOL is_renderer(struct filter *filter)
 {
-    IMediaPosition *media_position;
     IAMFilterMiscFlags *flags;
     BOOL ret = FALSE;
 
@@ -574,16 +590,11 @@ static BOOL is_renderer(struct filter *filter)
             ret = TRUE;
         IAMFilterMiscFlags_Release(flags);
     }
-    else if (SUCCEEDED(IBaseFilter_QueryInterface(filter->filter, &IID_IMediaPosition, (void **)&media_position)))
-    {
-        if (!has_output_pins(filter->filter))
-            ret = TRUE;
-        IMediaPosition_Release(media_position);
-    }
     else
     {
         update_seeking(filter);
-        if (filter->seeking && !has_output_pins(filter->filter))
+        if ((filter->seeking || filter->position) &&
+            !has_output_pins(filter->filter))
             ret = TRUE;
     }
     return ret;
@@ -654,6 +665,7 @@ static HRESULT WINAPI FilterGraph2_AddFilter(IFilterGraph2 *iface,
     list_add_head(&graph->filters, &entry->entry);
     entry->sorting = FALSE;
     entry->seeking = NULL;
+    entry->position = NULL;
     ++graph->version;
 
     return duplicate_name ? VFW_S_DUPLICATE_NAME : hr;
@@ -695,7 +707,7 @@ static HRESULT WINAPI FilterGraph2_RemoveFilter(IFilterGraph2 *iface, IBaseFilte
                     {
                         if (FAILED(hr = IPin_Disconnect(peer)))
                         {
-                            WARN("Failed to disconnect peer %p, hr %#lx.\n", peer, hr);
+                            WARN("Failed to disconnect peer %p, hr %#x.\n", peer, hr);
                             IPin_Release(peer);
                             IPin_Release(ppin);
                             IEnumPins_Release(penumpins);
@@ -705,7 +717,7 @@ static HRESULT WINAPI FilterGraph2_RemoveFilter(IFilterGraph2 *iface, IBaseFilte
 
                         if (FAILED(hr = IPin_Disconnect(ppin)))
                         {
-                            WARN("Failed to disconnect pin %p, hr %#lx.\n", ppin, hr);
+                            WARN("Failed to disconnect pin %p, hr %#x.\n", ppin, hr);
                             IPin_Release(ppin);
                             IEnumPins_Release(penumpins);
                             return hr;
@@ -721,6 +733,8 @@ static HRESULT WINAPI FilterGraph2_RemoveFilter(IFilterGraph2 *iface, IBaseFilte
             {
                 IBaseFilter_SetSyncSource(pFilter, NULL);
                 IBaseFilter_Release(pFilter);
+                if (entry->position)
+                    IMediaPosition_Release(entry->position);
                 if (entry->seeking)
                     IMediaSeeking_Release(entry->seeking);
                 list_remove(&entry->entry);
@@ -772,66 +786,80 @@ static HRESULT WINAPI FilterGraph2_FindFilterByName(IFilterGraph2 *iface,
     return VFW_E_NOT_FOUND;
 }
 
-static HRESULT check_cyclic_connection(IPin *source, IPin *sink)
+/* Don't allow a circular connection to form, return VFW_E_CIRCULAR_GRAPH if this would be the case.
+ * A circular connection will be formed if from the filter of the output pin, the input pin can be reached
+ */
+static HRESULT CheckCircularConnection(struct filter_graph *This, IPin *out, IPin *in)
 {
-    IPin *upstream_source, *upstream_sink;
-    PIN_INFO source_info, sink_info;
-    IEnumPins *enumpins;
+#if 1
     HRESULT hr;
+    PIN_INFO info_out, info_in;
 
-    hr = IPin_QueryPinInfo(sink, &sink_info);
+    hr = IPin_QueryPinInfo(out, &info_out);
     if (FAILED(hr))
-    {
-        ERR("Failed to query pin, hr %#lx.\n", hr);
         return hr;
-    }
-    IBaseFilter_Release(sink_info.pFilter);
-
-    hr = IPin_QueryPinInfo(source, &source_info);
-    if (FAILED(hr))
+    if (info_out.dir != PINDIR_OUTPUT)
     {
-        ERR("Failed to query pin, hr %#lx.\n", hr);
-        return hr;
-    }
-
-    if (sink_info.pFilter == source_info.pFilter)
-    {
-        WARN("Cyclic connection detected; returning VFW_E_CIRCULAR_GRAPH.\n");
-        IBaseFilter_Release(source_info.pFilter);
-        return VFW_E_CIRCULAR_GRAPH;
+        IBaseFilter_Release(info_out.pFilter);
+        return VFW_E_CANNOT_CONNECT;
     }
 
-    hr = IBaseFilter_EnumPins(source_info.pFilter, &enumpins);
+    hr = IPin_QueryPinInfo(in, &info_in);
+    if (SUCCEEDED(hr))
+        IBaseFilter_Release(info_in.pFilter);
     if (FAILED(hr))
+        goto out;
+    if (info_in.dir != PINDIR_INPUT)
     {
-        ERR("Failed to enumerate pins, hr %#lx.\n", hr);
-        IBaseFilter_Release(source_info.pFilter);
-        return hr;
+        hr = VFW_E_CANNOT_CONNECT;
+        goto out;
     }
 
-    while ((hr = IEnumPins_Next(enumpins, 1, &upstream_sink, NULL)) == S_OK)
+    if (info_out.pFilter == info_in.pFilter)
+        hr = VFW_E_CIRCULAR_GRAPH;
+    else
     {
-        PIN_DIRECTION dir = PINDIR_OUTPUT;
+        IEnumPins *enumpins;
+        IPin *test;
 
-        IPin_QueryDirection(upstream_sink, &dir);
-        if (dir == PINDIR_INPUT && IPin_ConnectedTo(upstream_sink, &upstream_source) == S_OK)
+        hr = IBaseFilter_EnumPins(info_out.pFilter, &enumpins);
+        if (FAILED(hr))
+            goto out;
+
+        IEnumPins_Reset(enumpins);
+        while ((hr = IEnumPins_Next(enumpins, 1, &test, NULL)) == S_OK)
         {
-            hr = check_cyclic_connection(upstream_source, sink);
-            IPin_Release(upstream_source);
-            if (FAILED(hr))
+            PIN_DIRECTION dir = PINDIR_OUTPUT;
+            IPin_QueryDirection(test, &dir);
+            if (dir == PINDIR_INPUT)
             {
-                IPin_Release(upstream_sink);
-                IEnumPins_Release(enumpins);
-                IBaseFilter_Release(source_info.pFilter);
-                return hr;
+                IPin *victim = NULL;
+                IPin_ConnectedTo(test, &victim);
+                if (victim)
+                {
+                    hr = CheckCircularConnection(This, victim, in);
+                    IPin_Release(victim);
+                    if (FAILED(hr))
+                    {
+                        IPin_Release(test);
+                        break;
+                    }
+                }
             }
+            IPin_Release(test);
         }
-        IPin_Release(upstream_sink);
+        IEnumPins_Release(enumpins);
     }
-    IEnumPins_Release(enumpins);
 
-    IBaseFilter_Release(source_info.pFilter);
+out:
+    IBaseFilter_Release(info_out.pFilter);
+    if (FAILED(hr))
+        ERR("Checking filtergraph returned %08x, something's not right!\n", hr);
+    return hr;
+#else
+    /* Debugging filtergraphs not enabled */
     return S_OK;
+#endif
 }
 
 static struct filter *find_sorted_filter(struct filter_graph *graph, IBaseFilter *iface)
@@ -857,7 +885,7 @@ static void sort_filter_recurse(struct filter_graph *graph, struct filter *filte
 
     TRACE("Sorting filter %p.\n", filter->filter);
 
-    /* Cyclic connections should be caught by check_cyclic_connection(). */
+    /* Cyclic connections should be caught by CheckCircularConnection(). */
     assert(!filter->sorting);
 
     filter->sorting = TRUE;
@@ -937,13 +965,13 @@ static HRESULT WINAPI FilterGraph2_ConnectDirect(IFilterGraph2 *iface, IPin *ppi
     {
         if (dir == PINDIR_INPUT)
         {
-            hr = check_cyclic_connection(ppinOut, ppinIn);
+            hr = CheckCircularConnection(This, ppinOut, ppinIn);
             if (SUCCEEDED(hr))
                 hr = IPin_Connect(ppinOut, ppinIn, pmt);
         }
         else
         {
-            hr = check_cyclic_connection(ppinIn, ppinOut);
+            hr = CheckCircularConnection(This, ppinIn, ppinOut);
             if (SUCCEEDED(hr))
                 hr = IPin_Connect(ppinIn, ppinOut, pmt);
         }
@@ -1265,7 +1293,7 @@ static HRESULT autoplug(struct filter_graph *graph, IPin *source, IPin *sink,
 
             if (callback && FAILED(hr = IAMGraphBuilderCallback_SelectedFilter(callback, moniker)))
             {
-                TRACE("Filter rejected by IAMGraphBuilderCallback::SelectedFilter(), hr %#lx.\n", hr);
+                TRACE("Filter rejected by IAMGraphBuilderCallback::SelectedFilter(), hr %#x.\n", hr);
                 IMoniker_Release(moniker);
                 continue;
             }
@@ -1274,14 +1302,14 @@ static HRESULT autoplug(struct filter_graph *graph, IPin *source, IPin *sink,
             IMoniker_Release(moniker);
             if (FAILED(hr))
             {
-                ERR("Failed to create filter for %s, hr %#lx.\n", debugstr_w(V_BSTR(&var)), hr);
+                ERR("Failed to create filter for %s, hr %#x.\n", debugstr_w(V_BSTR(&var)), hr);
                 VariantClear(&var);
                 continue;
             }
 
             if (callback && FAILED(hr = IAMGraphBuilderCallback_CreatedFilter(callback, filter)))
             {
-                TRACE("Filter rejected by IAMGraphBuilderCallback::CreatedFilter(), hr %#lx.\n", hr);
+                TRACE("Filter rejected by IAMGraphBuilderCallback::CreatedFilter(), hr %#x.\n", hr);
                 IBaseFilter_Release(filter);
                 continue;
             }
@@ -1290,7 +1318,7 @@ static HRESULT autoplug(struct filter_graph *graph, IPin *source, IPin *sink,
             VariantClear(&var);
             if (FAILED(hr))
             {
-                ERR("Failed to add filter, hr %#lx.\n", hr);
+                ERR("Failed to add filter, hr %#x.\n", hr);
                 IBaseFilter_Release(filter);
                 continue;
             }
@@ -1348,89 +1376,10 @@ static HRESULT WINAPI FilterGraph2_Connect(IFilterGraph2 *iface, IPin *source, I
 
     LeaveCriticalSection(&graph->cs);
 
-    TRACE("Returning %#lx.\n", hr);
+    TRACE("Returning %#x.\n", hr);
     return hr;
 }
 
-/* CW HACK 19248 */
-static BOOL is_bethesda_game(void)
-{
-    static const WCHAR *exe_names[] = { L"oblivion.exe", L"fallout3.exe", L"morrowind.exe" };
-    WCHAR name[MAX_PATH], *module_exe;
-    int i;
-
-    if (!GetModuleFileNameW(NULL, name, sizeof(name)))
-        return FALSE;
-
-    module_exe = wcsrchr(name, '\\');
-    module_exe = module_exe ? module_exe + 1 : name;
-
-    for (i = 0; i < ARRAY_SIZE(exe_names); i++) {
-        if (!_wcsicmp(module_exe, exe_names[i]))
-            return TRUE;
-    }
-
-    return FALSE;
-}
-
-static BOOL is_mac_os(void)
-{
-    const char *sysname;
-    void (CDECL *my_wine_get_host_version)(const char **sysname, const char **release);
-
-    my_wine_get_host_version = (void *)GetProcAddress(GetModuleHandleW(L"ntdll.dll"), "wine_get_host_version");
-    if (!my_wine_get_host_version)
-        return FALSE;
-
-    my_wine_get_host_version(&sysname, NULL);
-
-    return !strcmp(sysname, "Darwin");
-}
-
-static BOOL needs_mp3_hack(void)
-{
-    static BOOL needs_hack, did_check = FALSE;
-
-    if (!did_check) {
-        needs_hack = is_mac_os() && is_bethesda_game();
-        did_check = TRUE;
-    }
-
-    return needs_hack;
-}
-
-static BOOL is_mp3_file(LPCWSTR filename)
-{
-    LPCWSTR ext = wcsrchr(filename, '.');
-    if (!ext)
-        return FALSE;
-
-    return !_wcsicmp(ext, L".mp3");
-}
-
-static BOOL is_fallout3_mp3_source(IPin *source)
-{
-    static const CLSID fallout_source_clsid = { 0xc553f2c0, 0x1529, 0x11d0, { 0xb4, 0xd1, 0x00, 0x80, 0x5f, 0x6c, 0xbb, 0xea } };
-    PIN_INFO pin_info;
-    CLSID clsid;
-    HRESULT hr;
-
-    if (!source)
-        return FALSE;
-
-    hr = IPin_QueryPinInfo(source, &pin_info);
-    if (FAILED(hr))
-        return FALSE;
-
-    hr = IBaseFilter_GetClassID(pin_info.pFilter, &clsid);
-    IBaseFilter_Release(pin_info.pFilter);
-    if (FAILED(hr))
-        return FALSE;
-
-    return IsEqualGUID(&clsid, &fallout_source_clsid);
-}
-/* End hack */
-
 static HRESULT WINAPI FilterGraph2_Render(IFilterGraph2 *iface, IPin *source)
 {
     struct filter_graph *graph = impl_from_IFilterGraph2(iface);
@@ -1444,11 +1393,7 @@ static HRESULT WINAPI FilterGraph2_Render(IFilterGraph2 *iface, IPin *source)
     if (hr == VFW_E_CANNOT_CONNECT)
         hr = VFW_E_CANNOT_RENDER;
 
-    /* CW HACK 19248 */
-    if (FAILED(hr) && needs_mp3_hack() && is_fallout3_mp3_source(source))
-        hr = S_OK;
-
-    TRACE("Returning %#lx.\n", hr);
+    TRACE("Returning %#x.\n", hr);
     return hr;
 }
 
@@ -1501,13 +1446,8 @@ static HRESULT WINAPI FilterGraph2_RenderFile(IFilterGraph2 *iface, LPCWSTR lpcw
         if (!any)
         {
             if (FAILED(hr = IFilterGraph2_RemoveFilter(iface, preader)))
-                ERR("Failed to remove source filter, hr %#lx.\n", hr);
-
-            /* CW HACK 19248 */
-            if (needs_mp3_hack() && is_mp3_file(lpcwstrFile))
-                hr = S_OK;
-            else
-                hr = VFW_E_CANNOT_RENDER;
+                ERR("Failed to remove source filter, hr %#x.\n", hr);
+            hr = VFW_E_CANNOT_RENDER;
         }
         else if (partial)
         {
@@ -1520,7 +1460,7 @@ static HRESULT WINAPI FilterGraph2_RenderFile(IFilterGraph2 *iface, LPCWSTR lpcw
     }
     IBaseFilter_Release(preader);
 
-    TRACE("Returning %#lx.\n", hr);
+    TRACE("--> %08x\n", hr);
     return hr;
 }
 
@@ -1543,13 +1483,13 @@ static HRESULT WINAPI FilterGraph2_AddSourceFilter(IFilterGraph2 *iface,
     if (FAILED(hr = CoCreateInstance(&clsid, NULL, CLSCTX_INPROC_SERVER,
             &IID_IBaseFilter, (void **)&filter)))
     {
-        WARN("Failed to create filter, hr %#lx.\n", hr);
+        WARN("Failed to create filter, hr %#x.\n", hr);
         return hr;
     }
 
     if (FAILED(hr = IBaseFilter_QueryInterface(filter, &IID_IFileSourceFilter, (void **)&filesource)))
     {
-        WARN("Failed to get IFileSourceFilter, hr %#lx.\n", hr);
+        WARN("Failed to get IFileSourceFilter, hr %#x.\n", hr);
         IBaseFilter_Release(filter);
         return hr;
     }
@@ -1558,7 +1498,7 @@ static HRESULT WINAPI FilterGraph2_AddSourceFilter(IFilterGraph2 *iface,
     IFileSourceFilter_Release(filesource);
     if (FAILED(hr))
     {
-        WARN("Failed to load file, hr %#lx.\n", hr);
+        WARN("Failed to load file, hr %#x.\n", hr);
         return hr;
     }
 
@@ -1573,11 +1513,11 @@ static HRESULT WINAPI FilterGraph2_AddSourceFilter(IFilterGraph2 *iface,
     return S_OK;
 }
 
-static HRESULT WINAPI FilterGraph2_SetLogFile(IFilterGraph2 *iface, DWORD_PTR file)
+static HRESULT WINAPI FilterGraph2_SetLogFile(IFilterGraph2 *iface, DWORD_PTR hFile)
 {
-    struct filter_graph *graph = impl_from_IFilterGraph2(iface);
+    struct filter_graph *This = impl_from_IFilterGraph2(iface);
 
-    TRACE("graph %p, file %#Ix.\n", graph, file);
+    TRACE("(%p/%p)->(%08x): stub !!!\n", This, iface, (DWORD) hFile);
 
     return S_OK;
 }
@@ -1612,13 +1552,13 @@ static HRESULT WINAPI FilterGraph2_AddSourceFilterForMoniker(IFilterGraph2 *ifac
 
     hr = IMoniker_BindToObject(pMoniker, pCtx, NULL, &IID_IBaseFilter, (void**)&pfilter);
     if(FAILED(hr)) {
-        WARN("Failed to bind moniker, hr %#lx.\n", hr);
+        WARN("Unable to bind moniker to filter object (%x)\n", hr);
         return hr;
     }
 
     hr = IFilterGraph2_AddFilter(iface, pfilter, lpcwstrFilterName);
     if (FAILED(hr)) {
-        WARN("Failed to add filter, hr %#lx.\n", hr);
+        WARN("Unable to add filter (%x)\n", hr);
         IBaseFilter_Release(pfilter);
         return hr;
     }
@@ -1660,10 +1600,10 @@ static HRESULT WINAPI FilterGraph2_RenderEx(IFilterGraph2 *iface, IPin *source,
     struct filter_graph *graph = impl_from_IFilterGraph2(iface);
     HRESULT hr;
 
-    TRACE("graph %p, source %p, flags %#lx, context %p.\n", graph, source, flags, context);
+    TRACE("graph %p, source %p, flags %#x, context %p.\n", graph, source, flags, context);
 
     if (flags & ~AM_RENDEREX_RENDERTOEXISTINGRENDERERS)
-        FIXME("Unknown flags %#lx.\n", flags);
+        FIXME("Unknown flags %#x.\n", flags);
 
     EnterCriticalSection(&graph->cs);
     hr = autoplug(graph, source, NULL, !!(flags & AM_RENDEREX_RENDERTOEXISTINGRENDERERS), 0);
@@ -1671,7 +1611,7 @@ static HRESULT WINAPI FilterGraph2_RenderEx(IFilterGraph2 *iface, IPin *source,
     if (hr == VFW_E_CANNOT_CONNECT)
         hr = VFW_E_CANNOT_RENDER;
 
-    TRACE("Returning %#lx.\n", hr);
+    TRACE("Returning %#x.\n", hr);
     return hr;
 }
 
@@ -1725,52 +1665,47 @@ static ULONG WINAPI MediaControl_Release(IMediaControl *iface)
 
 }
 
-static HRESULT WINAPI MediaControl_GetTypeInfoCount(IMediaControl *iface, UINT *count)
+/*** IDispatch methods ***/
+static HRESULT WINAPI MediaControl_GetTypeInfoCount(IMediaControl *iface, UINT *pctinfo)
 {
-    TRACE("iface %p, count %p.\n", iface, count);
-    *count = 1;
+    struct filter_graph *This = impl_from_IMediaControl(iface);
+
+    TRACE("(%p/%p)->(%p): stub !!!\n", This, iface, pctinfo);
+
     return S_OK;
 }
 
-static HRESULT WINAPI MediaControl_GetTypeInfo(IMediaControl *iface, UINT index,
-        LCID lcid, ITypeInfo **typeinfo)
+static HRESULT WINAPI MediaControl_GetTypeInfo(IMediaControl *iface, UINT iTInfo, LCID lcid,
+        ITypeInfo **ppTInfo)
 {
-    TRACE("iface %p, index %u, lcid %#lx, typeinfo %p.\n", iface, index, lcid, typeinfo);
-    return strmbase_get_typeinfo(IMediaControl_tid, typeinfo);
+    struct filter_graph *This = impl_from_IMediaControl(iface);
+
+    TRACE("(%p/%p)->(%d, %d, %p): stub !!!\n", This, iface, iTInfo, lcid, ppTInfo);
+
+    return S_OK;
 }
 
-static HRESULT WINAPI MediaControl_GetIDsOfNames(IMediaControl *iface, REFIID iid,
-        LPOLESTR *names, UINT count, LCID lcid, DISPID *ids)
+static HRESULT WINAPI MediaControl_GetIDsOfNames(IMediaControl *iface, REFIID riid,
+        LPOLESTR *rgszNames, UINT cNames, LCID lcid, DISPID *rgDispId)
 {
-    ITypeInfo *typeinfo;
-    HRESULT hr;
+    struct filter_graph *This = impl_from_IMediaControl(iface);
 
-    TRACE("iface %p, iid %s, names %p, count %u, lcid %#lx, ids %p.\n",
-            iface, debugstr_guid(iid), names, count, lcid, ids);
+    TRACE("(%p/%p)->(%s, %p, %d, %d, %p): stub !!!\n", This, iface, debugstr_guid(riid), rgszNames,
+            cNames, lcid, rgDispId);
 
-    if (SUCCEEDED(hr = strmbase_get_typeinfo(IMediaControl_tid, &typeinfo)))
-    {
-        hr = ITypeInfo_GetIDsOfNames(typeinfo, names, count, ids);
-        ITypeInfo_Release(typeinfo);
-    }
-    return hr;
+    return S_OK;
 }
 
-static HRESULT WINAPI MediaControl_Invoke(IMediaControl *iface, DISPID id, REFIID iid, LCID lcid,
-        WORD flags, DISPPARAMS *params, VARIANT *result, EXCEPINFO *excepinfo, UINT *error_arg)
+static HRESULT WINAPI MediaControl_Invoke(IMediaControl *iface, DISPID dispIdMember, REFIID riid,
+        LCID lcid, WORD wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExepInfo,
+        UINT *puArgErr)
 {
-    ITypeInfo *typeinfo;
-    HRESULT hr;
+    struct filter_graph *This = impl_from_IMediaControl(iface);
 
-    TRACE("iface %p, id %ld, iid %s, lcid %#lx, flags %#x, params %p, result %p, excepinfo %p, error_arg %p.\n",
-            iface, id, debugstr_guid(iid), lcid, flags, params, result, excepinfo, error_arg);
+    TRACE("(%p/%p)->(%d, %s, %d, %04x, %p, %p, %p, %p): stub !!!\n", This, iface, dispIdMember,
+            debugstr_guid(riid), lcid, wFlags, pDispParams, pVarResult, pExepInfo, puArgErr);
 
-    if (SUCCEEDED(hr = strmbase_get_typeinfo(IMediaControl_tid, &typeinfo)))
-    {
-        hr = ITypeInfo_Invoke(typeinfo, iface, id, flags, params, result, excepinfo, error_arg);
-        ITypeInfo_Release(typeinfo);
-    }
-    return hr;
+    return S_OK;
 }
 
 static void update_render_count(struct filter_graph *graph)
@@ -1830,11 +1765,11 @@ static HRESULT graph_start(struct filter_graph *graph, REFERENCE_TIME stream_sta
         HRESULT filter_hr = IBaseFilter_Run(filter->filter, stream_start);
         if (hr == S_OK)
             hr = filter_hr;
-        TRACE("Filter %p returned %#lx.\n", filter->filter, filter_hr);
+        TRACE("Filter %p returned %#x.\n", filter->filter, filter_hr);
     }
 
     if (FAILED(hr))
-        WARN("Failed to start stream, hr %#lx.\n", hr);
+        WARN("Failed to start stream, hr %#x.\n", hr);
 
     return hr;
 }
@@ -1929,7 +1864,7 @@ static HRESULT WINAPI MediaControl_Run(IMediaControl *iface)
             HRESULT filter_hr = IBaseFilter_Pause(filter->filter);
             if (hr == S_OK)
                 hr = filter_hr;
-            TRACE("Filter %p returned %#lx.\n", filter->filter, filter_hr);
+            TRACE("Filter %p returned %#x.\n", filter->filter, filter_hr);
 
             /* If a filter returns VFW_S_CANT_CUE, we shouldn't wait for a
              * paused state. */
@@ -1941,7 +1876,7 @@ static HRESULT WINAPI MediaControl_Run(IMediaControl *iface)
         if (FAILED(hr))
         {
             LeaveCriticalSection(&graph->cs);
-            WARN("Failed to pause, hr %#lx.\n", hr);
+            WARN("Failed to pause, hr %#x.\n", hr);
             return hr;
         }
     }
@@ -1989,7 +1924,7 @@ static HRESULT WINAPI MediaControl_GetState(IMediaControl *iface, LONG timeout,
 {
     struct filter_graph *graph = impl_from_IMediaControl(iface);
 
-    TRACE("graph %p, timeout %ld, state %p.\n", graph, timeout, state);
+    TRACE("graph %p, timeout %u, state %p.\n", graph, timeout, state);
 
     if (timeout < 0) timeout = INFINITE;
 
@@ -2040,13 +1975,13 @@ static void CALLBACK wait_pause_cb(TP_CALLBACK_INSTANCE *instance, void *context
     HRESULT hr;
 
     if ((hr = IMediaControl_GetState(control, INFINITE, &state)) != S_OK)
-        ERR("Failed to get paused state, hr %#lx.\n", hr);
+        ERR("Failed to get paused state, hr %#x.\n", hr);
 
     if (FAILED(hr = IMediaControl_Stop(control)))
-        ERR("Failed to stop, hr %#lx.\n", hr);
+        ERR("Failed to stop, hr %#x.\n", hr);
 
     if ((hr = IMediaControl_GetState(control, INFINITE, &state)) != S_OK)
-        ERR("Failed to get paused state, hr %#lx.\n", hr);
+        ERR("Failed to get paused state, hr %#x.\n", hr);
 
     IMediaControl_Release(control);
 }
@@ -2058,7 +1993,7 @@ static void CALLBACK wait_stop_cb(TP_CALLBACK_INSTANCE *instance, void *context)
     HRESULT hr;
 
     if ((hr = IMediaControl_GetState(control, INFINITE, &state)) != S_OK)
-        ERR("Failed to get state, hr %#lx.\n", hr);
+        ERR("Failed to get state, hr %#x.\n", hr);
 
     IMediaControl_Release(control);
 }
@@ -2145,6 +2080,9 @@ static HRESULT all_renderers_seek(struct filter_graph *This, fnFoundSeek FoundSe
     HRESULT hr, hr_return = S_OK;
     struct filter *filter;
 
+    TRACE("(%p)->(%p %08lx)\n", This, FoundSeek, arg);
+    /* Send a message to all renderers, they are responsible for broadcasting it further */
+
     LIST_FOR_EACH_ENTRY(filter, &This->filters, struct filter, entry)
     {
         update_seeking(filter);
@@ -2336,7 +2274,7 @@ static HRESULT WINAPI MediaSeeking_GetDuration(IMediaSeeking *iface, LONGLONG *d
 
     LeaveCriticalSection(&graph->cs);
 
-    TRACE("Returning hr %#lx, duration %s (%s seconds).\n", hr,
+    TRACE("Returning hr %#x, duration %s (%s seconds).\n", hr,
             wine_dbgstr_longlong(*duration), debugstr_time(*duration));
     return hr;
 }
@@ -2444,7 +2382,7 @@ static HRESULT WINAPI MediaSeeking_SetPositions(IMediaSeeking *iface, LONGLONG *
     struct filter *filter;
     FILTER_STATE state;
 
-    TRACE("graph %p, current %s, current_flags %#lx, stop %s, stop_flags %#lx.\n", graph,
+    TRACE("graph %p, current %s, current_flags %#x, stop %s, stop_flags %#x.\n", graph,
             current_ptr ? wine_dbgstr_longlong(*current_ptr) : "<null>", current_flags,
             stop_ptr ? wine_dbgstr_longlong(*stop_ptr): "<null>", stop_flags);
     if (current_ptr)
@@ -2456,11 +2394,11 @@ static HRESULT WINAPI MediaSeeking_SetPositions(IMediaSeeking *iface, LONGLONG *
 
     if ((current_flags & 0x7) != AM_SEEKING_AbsolutePositioning
             && (current_flags & 0x7) != AM_SEEKING_NoPositioning)
-        FIXME("Unhandled current_flags %#lx.\n", current_flags & 0x7);
+        FIXME("Unhandled current_flags %#x.\n", current_flags & 0x7);
 
     if ((stop_flags & 0x7) != AM_SEEKING_NoPositioning
             && (stop_flags & 0x7) != AM_SEEKING_AbsolutePositioning)
-        FIXME("Unhandled stop_flags %#lx.\n", stop_flags & 0x7);
+        FIXME("Unhandled stop_flags %#x.\n", stop_flags & 0x7);
 
     EnterCriticalSection(&graph->cs);
 
@@ -2615,52 +2553,29 @@ static ULONG WINAPI MediaPosition_Release(IMediaPosition *iface)
     return IUnknown_Release(graph->outer_unk);
 }
 
-static HRESULT WINAPI MediaPosition_GetTypeInfoCount(IMediaPosition *iface, UINT *count)
+/*** IDispatch methods ***/
+static HRESULT WINAPI MediaPosition_GetTypeInfoCount(IMediaPosition *iface, UINT* pctinfo)
 {
-    TRACE("iface %p, count %p.\n", iface, count);
-    *count = 1;
-    return S_OK;
+    FIXME("(%p) stub!\n", iface);
+    return E_NOTIMPL;
 }
 
-static HRESULT WINAPI MediaPosition_GetTypeInfo(IMediaPosition *iface, UINT index,
-        LCID lcid, ITypeInfo **typeinfo)
+static HRESULT WINAPI MediaPosition_GetTypeInfo(IMediaPosition *iface, UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)
 {
-    TRACE("iface %p, index %u, lcid %#lx, typeinfo %p.\n", iface, index, lcid, typeinfo);
-    return strmbase_get_typeinfo(IMediaPosition_tid, typeinfo);
+    FIXME("(%p) stub!\n", iface);
+    return E_NOTIMPL;
 }
 
-static HRESULT WINAPI MediaPosition_GetIDsOfNames(IMediaPosition *iface, REFIID iid,
-        LPOLESTR *names, UINT count, LCID lcid, DISPID *ids)
+static HRESULT WINAPI MediaPosition_GetIDsOfNames(IMediaPosition* iface, REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)
 {
-    ITypeInfo *typeinfo;
-    HRESULT hr;
-
-    TRACE("iface %p, iid %s, names %p, count %u, lcid %#lx, ids %p.\n",
-            iface, debugstr_guid(iid), names, count, lcid, ids);
-
-    if (SUCCEEDED(hr = strmbase_get_typeinfo(IMediaPosition_tid, &typeinfo)))
-    {
-        hr = ITypeInfo_GetIDsOfNames(typeinfo, names, count, ids);
-        ITypeInfo_Release(typeinfo);
-    }
-    return hr;
+    FIXME("(%p) stub!\n", iface);
+    return E_NOTIMPL;
 }
 
-static HRESULT WINAPI MediaPosition_Invoke(IMediaPosition *iface, DISPID id, REFIID iid, LCID lcid,
-        WORD flags, DISPPARAMS *params, VARIANT *result, EXCEPINFO *excepinfo, UINT *error_arg)
+static HRESULT WINAPI MediaPosition_Invoke(IMediaPosition* iface, DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)
 {
-    ITypeInfo *typeinfo;
-    HRESULT hr;
-
-    TRACE("iface %p, id %ld, iid %s, lcid %#lx, flags %#x, params %p, result %p, excepinfo %p, error_arg %p.\n",
-            iface, id, debugstr_guid(iid), lcid, flags, params, result, excepinfo, error_arg);
-
-    if (SUCCEEDED(hr = strmbase_get_typeinfo(IMediaPosition_tid, &typeinfo)))
-    {
-        hr = ITypeInfo_Invoke(typeinfo, iface, id, flags, params, result, excepinfo, error_arg);
-        ITypeInfo_Release(typeinfo);
-    }
-    return hr;
+    FIXME("(%p) stub!\n", iface);
+    return E_NOTIMPL;
 }
 
 static HRESULT ConvertFromREFTIME(IMediaSeeking *seek, REFTIME time_in, LONGLONG *time_out)
